/*  min cost flow */
#include <stdio.h>
#include <math.h>
#include <set>
using namespace std;
struct edge {
  int c;
  double f;
  int mf;
} lnk[120][120];
int N,K,M;
int s=0,t;
double pi[120];
double d[120];
int from[120];
typedef pair<double,int> heapitem;
typedef set<heapitem> heap;
heap h;
heap::iterator hi;
double eps=1e-6;
int main()
{
  int i,v,a,b,f,c;
  double sf,sv,x,xc,coef,fm,ndist;
  freopen("input.txt","r",stdin);
  freopen("output.txt","w",stdout);
  scanf("%d%d%d",&N,&K,&M);
  t=N+K+1;
  sv=0;
  for(i=0;i<N;++i)
  { scanf("%d",&v);
    lnk[i+1][t].mf=v;
    sv+=v;
  }
  for(i=0;i<M;++i)
  {
    scanf("%d%d%d%d",&a,&b,&f,&c);
    lnk[a][b].mf=f;
    lnk[a][b].c=c;
  }
  sf=0;
  while(1)
  {
    h.clear();
    h.insert(heapitem(0.0,s));
    for(i=1;i<=t;i++)
      from[i]=-1;
    from[0]=0;
    while(!h.empty())
    {
      hi=h.begin();
      v=hi->second;
      h.erase(hi);
      for(i=0;i<=t;++i)
      {
        if(lnk[v][i].c<100 && lnk[v][i].f<lnk[v][i].mf-eps)
        {  ndist=d[v]-log10((100-lnk[v][i].c)/100.0)+pi[v]-pi[i];
           if(from[i]<0 || d[i]>ndist+eps)
           { if(from[i]>=0) h.erase(heapitem(d[i],i));
             d[i]=ndist;
             h.insert(heapitem(d[i],i));
             from[i]=v;
           }
        }
        if(lnk[i][v].c<100 && lnk[i][v].f>eps)
        {  ndist=d[v]+log10((100-lnk[i][v].c)/100.0)+pi[v]-pi[i];
           if(from[i]<0 || d[i]>ndist+eps)
           { if(from[i]>=0) h.erase(heapitem(d[i],i));
             d[i]=ndist;
             h.insert(heapitem(d[i],i));
             from[i]=v;
           }
        }
      }  
    }
    if(from[t]<0) break;
    for(i=0;i<=t;++i)
      if(from[i]>=0)
        pi[i]+=d[i];
      else
        pi[i]+=d[t]; /*?*/
    x=sv;
    xc=1;
    i=t;
    while(i!=0)
    { v=from[i];
      if(lnk[i][v].c<100 && lnk[i][v].f>eps)
      { coef=(100-lnk[i][v].c)/100.0;
        fm=lnk[i][v].f;
        if(x/xc>fm)
          x=fm*xc;
        xc/=coef;
      }
      else
      { xc*=(100-lnk[v][i].c)/100.0;
        fm=lnk[v][i].mf-lnk[v][i].f;
        if(x/xc>fm)
          x=fm*xc;
      }
      i=v;
    }
    xc=1;
    i=t;
    while(i!=0)
    { v=from[i];
      if(lnk[i][v].c<100 && lnk[i][v].f>eps)
      { coef=(100-lnk[i][v].c)/100.0;
        lnk[i][v].f-=x/xc;
        xc/=coef;
      }
      else
      { xc*=(100-lnk[v][i].c)/100.0;
        lnk[v][i].f+=x/xc;
      }
      i=v;
    }
    sv-=x;
    sf+=x/xc;
    if(sv<eps) break;
  }
  if(sv<eps) printf("%.5lf\n",sf);
  else printf("-1\n");
  return 0;
}
